# 运用git flow 来处理一下场景

    - 主分支 master 开发分支 dev 
    - 赤山项目代码是最新的tagv3.0.9
    - 环球项目代码版本是tag3.0.2(与最新版本差距7次迭代,不完全兼容最新版!)

## 预设:

  1. 本周定版,3.0.10,需要开发4个新功能:A,B,C,D;
  2. 同时还有一个新功能E,是下一个版本的功能,但是需要本周同步开发
  3. 对于dev分支,变动时,将自动部署到测试环境
  4. 对于release分支,上传到线上会自动打beta版本
  5. 对于正式发布的版本,会为tag打正式版,并删除beta版本

## case1: 周一时,如何对上述4个新功能进行开发,git flow如何操作?

```
根据需求各自从dev分支建立feature分支
```

## case2: 周4下午,当这4个功能都开发完成后,现在要进行封版处理,如何操作?

```
测试完成合并到dev dev自动部署测试环境
```

## case3:  功能E对开始开发时间有要求吗?对合并时间有要求吗?

```
当前版本不能合并 开发时间没说
```

## case4: 周5到周6,测试人员对即将发布的新版本3.0.10(beta)进行了测试,发现了新的bug,如何处理?

```
从测试环境创建分支fix3.0.10_bug编号进行修改
```

## case5: 下周一,上周的3.0.10测试完全通过,也没发现新的问题,需要正式发布,如何操作?

```
合并到master分支 打上tag3.0.10
```

## case6: 又过了2天,项目里发现一个严重的bug,需要立马修复,如何操作?

```
从master创建分支hotfix3.0.10_bug编号进行修改 自测通过后走dev测试 成功合并到master 打上bug编号的tag
```

## case7: 环球项目,有一特殊需求新功能D需要开发,开发完成后测试并部署到项目中去,该如何操作?

```
从release3.0.2分支创建support_需求编号分支 从该分支创建feature分支 开发完合并到support分支 测试完成封存support 删除feature
```

