# 运用git flow 来处理一下场景
    - 主分支 master 开发分支 dev 
    - 赤山项目代码是最新的tagv3.0.9
    - 环球项目代码版本是tag3.0.2(与最新版本差距7次迭代,不完全兼容最新版!)
## 预设:
 1. 本周定版,3.0.10,需要开发4个新功能:A,B,C,D;
 2. 同时还有一个新功能E,是下一个版本的功能,但是需要本周同步开发
 3. 对于dev分支,变动时,将自动部署到测试环境
 4. 对于release分支,上传到线上会自动打beta版本
 5. 对于正式发布的版本,会为tag打正式版,并删除beta版本

## case1: 周一时,如何对上述4个新功能进行开发,git flow如何操作?
```
按照每个功能新建出各个feature分支
git flow:
git flow feature start A
git flow feature start B
git flow feature start C
git flow feature start D

```

## case2: 周4下午,当这4个功能都开发完成后,现在要进行封版处理,如何操作?
```
开发人员将功能全部finish到dev，再新建出release3.0.10版本
git flow:
git flow feature finish A
git flow feature finish B
git flow feature finish C
git flow feature finish D
git flow release start 3.0.10
```

## case3:  功能E对开始开发时间有要求吗?对合并时间有要求吗?
```
开发时间无要求，合并时间需在release/3.0.10 finish之后在进行合并
```

## case4: 周5到周6,测试人员对即将发布的新版本3.0.10(beta)进行了测试,发现了新的bug,如何处理?

```
git flow bugfix start bugfix_{bug} release/3.0.10 
git flow bugfix finish bugfix_{bug}
或者
直接在release/3.0.10分支上进行修改
```
## case5: 下周一,上周的3.0.10测试完全通过,也没发现新的问题,需要正式发布,如何操作?

```
将release 3.0.10版本合并回master
git flow release finish 3.0.10
将master 3.0.10 交给部署人员去部署到项目上去
```
## case6: 又过了2天,项目里发现一个严重的bug,需要立马修复,如何操作?
```
git flow hotfix start hotfix3.0.10_bug  
git flow hotfix finish hotfix3.0.10_bug
git flow release start 3.0.10_bug
git flow release finish 3.0.10_bug
将master 3.0.10_bug 交给部署人员去部署到项目上去
```

## case7: 环球项目,有一特殊需求新功能D需要开发,开发完成后测试并部署到项目中去,该如何操作?
```
由于环球项目已经落后多个版本，使用新版可能会造成意外的问题，所以应该为项目单独新建出一个长期的分支，进行后续的需求开发
git flow support start huanqiu 3.0.2
git flow feature start D
git flow feature finish D
git flow release start 3.0.2_D
git flow release finish 3.0.2_D
将huanqiu新分支 3.0.2_D 交给部署人员去部署到项目上去
```
